#define STRICT
#define ORBITER_MODULE

#include "orbitersdk.h"
#include <time.h>
#include <cmath>
#include <vector>
#include <fstream>
#include <string>
#include <sstream>
#include "FileReader.h"

#define BUFLEN 255
//#define FOV 80*RAD

int GetRand(int from, int to)
{
	return rand() % to + from;
}
double GDRand(double from, double  span)
{
	return (double)rand() / (double)RAND_MAX * span + from;
}
int _OBJ_COUNT = 20;
#define KM 1000
std::vector<OBJHANDLE> hVes;
std::vector<std::string> meshes;
BOOL Init = FALSE;
FILEREADER g_FR;
VECTOR3 ofs = {50,50,300};
VECTOR3 vofs = {5, 5, 20};
VECTOR3 rotofs = {1.8, 1.8, 1.8};
VECTOR3 d_ofs = {100,100,500}; 
//VECTOR3 relV = {0,0,-120};
VECTOR3 relV = {0,0,0};
void init(void)
{
	//char cbuf[BUFLEN];
	//char str[BUFLEN];
	/*
    g_FR.LoadVector(ini,"SETTINGS","destroy_ofs",d_ofs);
	g_FR.LoadVector(ini,"SETTINGS","create_ofs",ofs);
	g_FR.LoadInt(ini,"SETTINGS","count",_OBJ_COUNT);
	g_FR.LoadVector(ini,"SETTINGS","relvel",relV);
	g_FR.LoadDouble(ini,"SETTINGS","renderalt",A_ofs);
	*/
	
	std::ifstream ini;
	ini.open ("./Modules/Plugin/orbscn.ini");
	if (ini.is_open())
	{
		while (!ini.eof())
		{
			std::string line;
			std::getline(ini, line);
			size_t len = strlen("count=");
			if (!line.compare(0,len,"count=") && line.size() > len)  
			{
				line.assign(line, len, line.size());
				std::stringstream ssbuf(line);
				ssbuf >> _OBJ_COUNT;
			}
		}
		ini.close();
	}
	
	for (int i = 0; i < _OBJ_COUNT; i++)
	{
		OBJHANDLE h = 0;
		char name[BUFLEN];
		sprintf(name, "obj_%d",i+1);
		h = oapiGetVesselByName(name);
		// NULL handle is OK. We'll create the vessel then
		hVes.push_back(h);
		
	}
	int mCount = 0; 
	/*
	g_FR.LoadInt(ini,"SETTINGS","mesh_count",mCount);
	
	for (int i = 0; i < mCount; i++)
	{
		sprintf(cbuf,"mesh_%d_name",i+1);
		g_FR.LoadString(ini,"SETTINGS",cbuf,str);
		meshes.push_back(std::string(str));
	}
	*/
	//mCount = 2;
	meshes.push_back("phobos");
	meshes.push_back("deimos");
	//meshes.push_back("carina");
	
	
	
}


DLLCLBK void opcPreStep(double simt, double simdt, double mjd)
{
	if (oapiGetTimeAcceleration() > 10) 
	{
		return;
	}
	char name[BUFLEN];
	VESSEL * v = oapiGetFocusInterface();
	VECTOR3 posRoid, posShip;
	VESSELSTATUS vs;
	memset(&vs, 0, sizeof(vs));
	
	if (Init == FALSE)
	{
		
		srand(time(NULL));
		Init = TRUE;
	
		init();
		vs.rbody = v->GetSurfaceRef();
		double rad = 2 * oapiGetSize (v->GetSurfaceRef());
		if (rad == 0) rad ++;
		double vel = sqrt (GGRAV * oapiGetMass (v->GetSurfaceRef()) / rad);
		vs.rpos = _V(rad,0,0);
		vs.rvel = _V(0,0,vel);


		for (unsigned int i = 0; i < hVes.size(); i++)
		{	
			if (!hVes.at(i))
			{
				memset(name, 0, sizeof(name));
				sprintf(name,"obj_%d",i+1);
				hVes[i] = oapiCreateVessel(name,"roid",vs);
				//VESSEL(hVes[i]).AddMesh(meshes[GetRand(0,meshes.size())].c_str());
			}
			try 
			{
				//VESSEL(hVes[i]).AddMesh(meshes.at(0).c_str());
				
				VESSEL(hVes[i]).AddMesh(meshes.at(GetRand(0, meshes.size())).c_str());
			}
			catch (...)
			{
				sprintf(oapiDebugString(), "Exception at mesh adding");
			}
		}
		
	}
	
	
	if (v->GroundContact())
		return;

	double A_ofs = 0;
	OBJHANDLE hRef = v->GetSurfaceRef();
	if (oapiPlanetHasAtmosphere(hRef))
	{
		const ATMCONST * atm = oapiGetPlanetAtmConstants(hRef);
		if (atm)	
		{
			// 50 km above the atmosphere
			A_ofs = atm->altlimit + 50 * KM;
		}
	}
	else
	{
		// if the body has no atmosphere then render 20 km above the surface
		A_ofs = 20 * KM;
	}

	if (v->GetAltitude() < A_ofs)
		return;
	if (FindWindow(NULL,(LPCWSTR)"Orbiter: Select spacecraft"))
		return;
		
	double x, y, z, vx, vy, vz, rx, ry, rz;
	x = y = z = vx = vy = vz = rx = ry = rz = 0;
	
	
	
	v->GetStatus(vs);
	//oapiGetGlobalPos(v->GetHandle(),&posShip);
	//v->Global2Local(posShip,posShip);	    
	double fov = oapiCameraAperture();
	fov *= 2.667; // something is wrong with the FOV or my math so I have to increase it
	//double fov = 80 * RAD;
	d_ofs.x = d_ofs.y = d_ofs.z * tan(fov/2);
	//sprintf(oapiDebugString(), "fov = %.2lf", fov*DEG);
	//sprintf(oapiDebugString(), "fov = %.2lf, d_ofs.z= %.2lf, d_ofs.x = %.2lf",fov*DEG,  d_ofs.z, d_ofs.x);
	
	for (unsigned int i = 0; i < hVes.size(); i++)
	{
		oapiGetGlobalPos(hVes[i],&posRoid);
		v->Global2Local(posRoid,posRoid);

		if ( (posRoid.z < 0) || (fabs(posRoid.z) > d_ofs.z)
			|| (fabs(posRoid.y) > posRoid.z / d_ofs.z * d_ofs.y) 
			|| (fabs(posRoid.x) > posRoid.z / d_ofs.z * d_ofs.x))
		{
			VESSEL * vRoid = oapiGetVesselInterface(hVes[i]);
			if (!vRoid) return;
			
			/*
			z = GDRand(1, ofs.z);
			x = GDRand(-ofs.x,ofs.x);
			if (GetRand(1,10) > 5)
				x = -x;
			y = GDRand(0,ofs.y);
			if (GetRand(1,10) > 5)
				y = -y;
			*/
			// if thrusting, generate far away
			if (v->GetThrusterGroupLevel(THGROUP_MAIN))
				z = GDRand(ofs.z * 0.6, ofs.z);	
			else
				z = GDRand(ofs.z * 0.1, ofs.z);	
			bool genClose = false;
			if (z < ofs.z*0.5) // if generated at close distance
			{
				// make the objects appear from the borders of your screen
				ofs.x = ofs.y = z / d_ofs.z * d_ofs.x;	
				genClose = true;
				if (GetRand(1,10) > 5)
				{
					x = ofs.x;
					if (GetRand(1,10) > 5)
						x = -x;
					y = GDRand(0,ofs.y);
				}			
				else
				{
					y = ofs.y;
					if (GetRand(1,10) > 5)
						y = -y;
					x = GDRand(-ofs.x,ofs.x);
				}
			}			
			else 
			{
				ofs.x = ofs.y = d_ofs.x / d_ofs.z * d_ofs.x * 0.7;	
				x = GDRand(-ofs.x,ofs.x);
				y = GDRand(0,ofs.y);
				//x = GDRand(- z / ofs.z * ofs.x, z / ofs.z * ofs.x);
				if (GetRand(1,10) > 5)
					x = -x;
				//y = GDRand(0,z / ofs.z * ofs.y);
				if (GetRand(1,10) > 5)
					y = -y;
			}
					
			
			//y = x= 0;	
		    //sprintf(oapiDebugString(), "z = %.2lf, x = %.2lf,y = %.2lf",z,x,y);
			vx = GDRand(-vofs.x,vofs.x);
			vy = GDRand(0,vofs.y);
			vz = GDRand(-vofs.z,vofs.z);
			
			if (genClose) // prevent disappearing imediately
			{
				if (x > 0 && vx > 0) vx = -vx;
				if (y > 0 && vy > 0) vy = -vy;
				vz /= 3;
				//if (z > 0 && vz > 0) vz = -vz
			}
			else 
			{
				if (GetRand(1,10) > 5)
					vx = -vx;
				if (GetRand(1,10) > 5)
					vy = -vy;
				//if (GetRand(1,10) > 5)
				//	vz = -vz;
			}			
			if (GetRand(1,10) > 5)
				vz = -vz;

			relV.x = vx;	
			relV.y = vy;
			relV.z = vz;
			
			rx = GDRand(-rotofs.x,rotofs.x);
			ry = GDRand(-rotofs.y,rotofs.y);
			rz = GDRand(-rotofs.z,rotofs.z);
			if (GetRand(1,10) > 5)
					rx = -rx;
			if (GetRand(1,10) > 5)
				ry = -ry;
			if (GetRand(1,10) > 5)
					rz = -rz;
			
			posShip.x += x;
			posShip.y += y;
			posShip.z += z;
			v->Local2Rel(posShip,posShip);
		    VECTOR3 rofs;
	        v->GlobalRot(relV,rofs);
	        vs.rpos = posShip;
			
			vs.vrot.x = rx;
			vs.vrot.y = ry;
			vs.vrot.z = rz;
			//vs.rposRoid.x += 30;
			//vs.rpos.x += x;
			//vs.rpos.y += y;
			//vs.rpos.z += z;
            vs.rvel+=rofs;
			
		    vRoid->DefSetState(&vs);
		}
	}
}